## WARNING:
## This code is a complete hack, may or may not work, etc..
## Use your own risk.  You have been warned.

walkCode <- function(e, w = makeCodeWalker()) {
    if (typeof(e) == "language") {
        if (typeof(e[[1]]) %in% c("symbol", "character")) {
            h <- w$handler(as.character(e[[1]]), w)
            if (! is.null(h)) h(e, w)
            else w$call(e, w)
        }
        else w$call(e, w)
    }
    else w$leaf(e, w)
}
makeCodeWalker <- function(...,
                           handler = function (v, w) NULL,
                           call = function(e, w)
                               for (ee in as.list(e))
                                   if (! missing(ee)) walkCode(ee, w),
                           leaf = function(e, w) print(e))
     list(handler = handler, call = call, leaf = leaf, ...)
showTree <- function(e, write = cat) {
    w <- makeCodeWalker(call = showTreeCall, leaf = showTreeLeaf,
                        write = write)
    walkCode(e, w)
    w$write("\n")
}
showTreeCall <- function(e, w) {
    w$write("(")
    walkCode(e[[1]], w)
    for (a in as.list(e[-1])) {
        w$write(" ");
        walkCode(a, w);
    }
    w$write(")")
}
showTreeLeaf <- function(e, w) {
    if (typeof(e) == "symbol") {
        if (e == "(") w$write("\"(\"")
        else if (e == "{") w$write("\"{\"")
        else w$write(e)
    }
    else w$write(deparse(e))
}
callCC <- function(fun) {
    value <- NULL
    delayedAssign("throw", return(value))
    fun(function(v) { value <<- v; throw })
}
makeConstantFolder <- function(...,
                               leaf = foldLeaf,
                               handler = function(v, w)
                                   if (w$foldable(v, w)) foldCall,
                               call = function(e, w) exitFolder(e, w),
                               exit = function(e, w)
                                  stop(paste("not a foldable expression:",
                                      deparse(e))),
                               isLocal = function(v, w) FALSE,
                               foldable = isFoldable,
                               isConstant = isConstantValue,
                               signal = function(e, msg, w) warning(msg))
     list(handler = handler, call = call, exit = exit, leaf = leaf,
          isLocal = isLocal, foldable = isFoldable,
          isConstant = isConstant, signal = signal, ...)

exitFolder <- function(e, w) {
    w$exit(e, w)
    stop("constant folding cannot continue")
}
constantFold <- function(e, env = NULL, fail = NULL) {
    job <- function(exit) {
        isLocal <- function(v, w) as.character(v) %in% env
        doExit <- function(e, w) exit(fail)
        w <- makeConstantFolder(isLocal = isLocal, exit = doExit)
        walkCode(e, w)
    }
    callCC(job)
}
isConstantValue <- function(v, w)
    is.null(v) || (is.null(attributes(v)) && is.atomic(v))
isFoldable <- function(v, w)
    ((typeof(v) == "symbol" || typeof(v) == "character") &&
     as.character(v) %in% foldFuns && ! w$isLocal(v, w))

foldFuns <- c("+", "-", "*", "/", "^", "(",
              ">", ">=", "==", "!=", "<", "<=", "||", "&&", "!",
              "|", "&", "%%",
              "sqrt", "log", "exp",
              "c", "as.integer", "vector", "integer","numeric","character",
              "rep",
              ":",
              "cos", "sin", "tan", "acos", "asin", "atan", "atan2")
constNames <- c("pi", "T", "F")

foldLeaf <- function(e, w) {
    if (is.name(e) && as.character(e) %in% constNames && ! w$isLocal(e, w))
        e <- get(as.character(e), env = NULL)
    if (! w$isConstant(e)) exitFolder(e, w)
    e
}
foldCall <- function(e, w) {
    args <- lapply(e[-1], function(e) walkCode(e, w))
    if (all(sapply(args, w$isConstant, w))) { # should be true
        fname <- as.character(e[[1]])
        msg <- try({ v <- do.call(fname, args); NULL }, silent = TRUE)
        if (! is.null(msg)) {
            w$signal(e, msg, w)
            exitFolder(e, w)
        }
        else if (w$isConstant(v, w)) v
        else exitFolder(e, w)
    }
    else exitFolder(e, w)
}
makeLocalsCollector <- function(...,
                                leaf = function (e, w) character(0),
                                handler = getCollectLocalsHandler,
                                isLocal = function(v, w) FALSE,
                                exit = function(e, msg, w) stop(msg),
                                collect = function(v, e, w) print(v))
    makeCodeWalker(leaf = leaf, handler = handler, collect = collect,
                   isLocal = isLocal)
collectLocals <- function(e, collect) {
    w <- makeLocalsCollector(collect = collect)
    walkCode(e, w)
}
getCollectLocalsHandler <- function(v, w) {
    switch(v,
           "=" =,
           "<-" = collectLocalsAssignHandler,
           "for" = collectLocalsForHandler,
           "function" =,
           "~" = function(e, w) character(0),
           "local" = if (! w$isLocal(v, w))
               collectLocalsLocalHandler,
           "expression" =,
           "quote" = if (! w$isLocal(v, w))
               function(e, w) character(0),
           "assign" = function(e, w)
               if (length(e) == 3 && is.character(e[[2]]) &&
                   length(e[[2]]) == 1) {
                   w$collect(e[[2]], e, w)
                   walkCode(e[[3]], w)
               }
               else for (a in dropMissings(e[-1])) walkCode(a, w))
}
dropMissings <- function(x) {
    lx <- as.list(x)
    ix <- rep(TRUE, length(x))
    for (i in seq(along = ix)) {
        a <- lx[[i]]
        if (missing(a)) ix[i] <- FALSE
    }
    lx[ix]
}
collectLocalsAssignHandler <- function(e, w) {
    w$collect(getAssignedVar(e), e, w)
    walkCode(e[[2]], w)
    walkCode(e[[3]], w)
}

collectLocalsForHandler <- function(e, w) {
    signal <- function(msg) w$exit(e, msg, w)
    w$collect(as.character(checkSymOrString(e[[2]], signal)), e, w)
    walkCode(e[[3]], w)
    walkCode(e[[4]], w)
}

checkSymOrString <- function(e, signal = stop) {
    type <- typeof(e)
    if (type == "symbol" || type == "character") e
    else signal("not a symbol or string")
}
collectLocalsLocalHandler <- function(e, w) {
    if (length(e) == 2) # no explicit env
        character(0)
    else for (a in dropMissings(e[-1])) walkCode(a, w)
}
findLocals <- function(e) {
    env <- new.env(hash = TRUE, parent = NULL)
    collect <- function(v, e, w) assign(v, TRUE, env = env)
    collectLocals(e, collect)
    ls(env, all = TRUE)
}
findLocalsList <- function(elist, envir = NULL) {
    localStopFuns <- c("expression", "quote", "local")
    if (is.character(envir))
        locals <- envir
    else
        locals <- localStopFuns[! sapply(localStopFuns,isBaseVar, envir)]
    specialSyntaxFuns <- c("~", "<-", "=", "for", "function")
    sf <- unique(c(locals, localStopFuns))
    nsf <- length(sf)
    collect <- function(v, e, w) assign(v, TRUE, env = env)
    isLocal <- function(v, w) as.character(v) %in% sf
    w <- makeLocalsCollector(collect = collect, isLocal = isLocal)
    repeat {
        env <- new.env(hash = TRUE, parent = NULL)
        for (e in elist) walkCode(e, w)
        isloc <- sapply(sf, exists, env = env, inherits = FALSE)
        if (nsf == length(locals) || length(sf[isloc] == nsf)) {
            vals <- ls(env, all = TRUE)
            rdsf <- vals %in% specialSyntaxFuns
            if (any(rdsf))
                warning(paste("local assignments to syntactic functions:",
                              vals[rdsf]))
            return(vals)
        }
        else {
            sf <- unique(c(locals, sf[isloc]))
            nsf <- length(sf)
        }
    }
}

findLocals <- function(e, envir = NULL)
    findLocalsList(list(e), envir)
findOwnerEnv <- function(v, env, stop = NA, default = NA) {
    while (! identical(env, stop))
        if (exists(v, env = env, inherits = FALSE))
            return(env)
        else if (is.null(env))
            return(default)
        else env <- parent.env(env)
    default
}
isBaseVar<-function(v, env) {
    e<-findOwnerEnv(v, env)
    is.null(e) || identical(e, .BaseNamespaceEnv)
}
isBaseVar <- function (v, env) 
{
    e <- findOwnerEnv(v, env)
    is.null(e) || identical(e, .BaseNamespaceEnv) || v == "@<-"
}
findFuncLocals <- function(formals, body)
   findLocalsList(c(list(body), dropMissings(formals)))
getAssignedVar <- function(e) {
    v <- e[[2]]
    if (typeof(v) %in% c("symbol", "character"))
        as.character(v)
    else {
        while (typeof(v) == "language")
            v <- v[[2]]
        if (typeof(v) != "symbol")
            stop(paste("bad assignment:", as.expression(e)))
        as.character(v)
    }
}
evalseq <- function(e) {
    if (typeof(e) == "language") {
        v <- evalseq(e[[2]])
        e[[2]] <- as.name("*tmp*")
        c(v, list(e))
    }
    else list(e)
}
apdef <- function(e) {
    v <- NULL
    tmp <- as.name("*tmp*")
    tmpv <- as.name("*tmpv*")
    while (typeof(e) == "language") {
        fun <- paste(as.character(checkSymOrString(e[[1]])), "<-", sep = "")
        ef <- e
        ef[[1]] <- as.name(fun)
        if (typeof(ef[[2]]) == "language")
            ef[[2]] <- tmp
        ef$value <- tmpv
        v <- c(v, list(ef))
        e <- e[[2]]
    }
    v
}
flattenAssignment <- function(e) {
    if (typeof(e) == "language")
        list(evalseq(e[[2]]), apdef(e))
    else list(NULL, NULL)
}
makeUsageCollector <- function(fun, ..., name = NULL,
                               enterLocal = doNothing,
                               enterGlobal = doNothing,
                               enterInternal = doNothing,
                               startCollectLocals = doNothing,
                               finishCollectLocals = doNothing,
                               warn = warning,
                               signal = signalUsageIssue) {
    if (typeof(fun) != "closure")
        stop("only works for closures")
    makeCodeWalker(..., name = name,
                   enterLocal = enterLocal,
                   enterGlobal = enterGlobal,
                   enterInternal = enterInternal,
                   startCollectLocals = startCollectLocals,
                   finishCollectLocals = finishCollectLocals,
                   warn = warn,
                   signal = signal,
                   leaf = collectUsageLeaf,
                   call = collectUsageCall,
                   handler = getCollectUsageHandler,
                   globalenv = environment(fun),
                   env = environment(fun),
                   name = NULL,
                   isLocal = collectUsageIsLocal)
}

collectUsage <- function(fun, name = "<anonymous>", ...) {
    w <- makeUsageCollector(fun, ...)
    collectUsageFun(name, formals(fun), body(fun), w)
}
collectUsageLeaf  <- function(v, w) {
    if (typeof(v) == "symbol") {
        vn <- as.character(v)
        if (v == "...")
            w$signal("... may be used in an incorrect context", w)
        else if (isDDSym(v)) {
            if (w$isLocal("...", w))
                w$enterLocal("variable", "...", v, w)
            else
                w$signal(paste(v, "may be used in an incorrect context", w), w)
        }
        else if (w$isLocal(vn, w))
            w$enterLocal("variable", vn, v, w)
        else if (! vn %in% c("*tmp*", "*tmpv*"))
            w$enterGlobal("variable", vn, v, w)
    }
}

collectUsageArgs <- function(e, w) {
    for (a in dropMissings(e[-1]))
        if (typeof(a) == "symbol" && a == "...") {
            if (w$isLocal("...", w))
                w$enterLocal("variable", "...", v, w)
            else
                w$signal(paste(a, "may be used in an incorrect context", w), w)
        }
        else walkCode(a, w)
}

collectUsageCall <- function(e, w) {
    if (typeof(e[[1]]) %in% c("symbol", "character")) {
        fn <- as.character(e[[1]])
        if (w$isLocal(fn, w))
            w$enterLocal("function", fn, e, w)
        else w$enterGlobal("function", fn, e, w)
    }
    else walkCode(e[[1]], w)
    collectUsageArgs(e, w)
}

collectUsageFun <- function(name, formals, body, w) {
    w$name <- c(w$name, name)
    parnames <- names(formals)
    locals <- findFuncLocals(formals, body)
    w$env <- new.env(hash = TRUE, parent = w$env)
    for (n in c(parnames, locals))
        assign(n, TRUE, w$env)
    w$startCollectLocals(parnames, locals, w)
    for (a in dropMissings(formals)) walkCode(a, w)
    walkCode(body, w)
    w$finishCollectLocals(w)
}

signalUsageIssue <- function(m, w)
    w$warn(paste(paste(w$name, collapse = " : "), ": ", m, "\n", sep = ""))

# **** is this the right handling of ..n things?
# **** signal (possible) error if used in wrong context?
# **** also need error for ... when not present
# **** maybe better done in leaf?
collectUsageIsLocal <- function(v, w) {
    if (isDDSym(v)) v <- "..."
    ! is.null(findOwnerEnv(v, w$env, stop = w$globalenv, default = NULL))
}

doNothing <- function(...) NULL
collectUsageHandlers <-new.env(hash=TRUE, parent = NULL)

# 'where' is ignored for now
addCollectUsageHandler <- function(v, where, fun)
    assign(v, fun, env = collectUsageHandlers)

getCollectUsageHandler <- function(v, w)
    if (exists(v, env = collectUsageHandlers, inherits = FALSE) &&
        isBaseVar(v, w$env) )  # **** for now
        get(v, env = collectUsageHandlers)

isSimpleFunDef <- function(e, w)
    typeof(e[[2]]) != "language" && typeof(e[[3]]) == "language" &&
    typeof(e[[3]][[1]]) %in% c("symbol", "character") &&
    e[[3]][[1]] == "function" && isBaseVar("function", w$env)

checkDotsAssignVar <- function(v, w) {
    if (v == "...") {
        w$signal("... may be used in an incorrect context", w)
        FALSE
    }
    else if (isDDSym(v)) {
        w$signal(paste(v, "may be used in an incorrect context", w), w)
        FALSE
    }
    else TRUE
}

#**** proceeds even if "..." or "..1", etc--is that right?
local({
    h <- function(e, w) {
        w$enterGlobal("function", as.character(e[[1]]), e, w)
        v <- getAssignedVar(e)
        checkDotsAssignVar(v, w)
        w$enterLocal("<-", v, e, w)
        if (isSimpleFunDef(e, w))
            collectUsageFun(v, e[[3]][[2]], e[[3]][[3]], w)
        else {
            if (typeof(e[[2]]) == "language") {
                fa <- flattenAssignment(e[[2]])
                for (a in fa)
                    for (b in a) walkCode(b, w)
            }
            walkCode(e[[3]], w)
        }
    }
    addCollectUsageHandler("<-", "base", h)
    addCollectUsageHandler("=", "base", h)
})

#**** proceeds even if "..." or "..1", etc--is that right?
addCollectUsageHandler("<<-", "base", function(e, w) {
    w$enterGlobal("function", "<<-", e, w)
    v <- getAssignedVar(e)
    checkDotsAssignVar(v, w)
    if (w$isLocal(v, w))
        w$enterLocal("<<-", v, e, w)
    else w$enterGlobal("<<-", v, e, w)
    if (typeof(e[[2]]) == "language") {
        fa <- flattenAssignment(e[[2]])
        for (a in fa)
            for (b in a) walkCode(b, w)
    }
    walkCode(e[[3]], w)
})

addCollectUsageHandler("for", "base", function(e, w) {
    w$enterGlobal("function", "for", e, w)
    v <- as.character(e[[2]])
    w$enterLocal("for", v, e, w)
    walkCode(e[[3]], w)
    walkCode(e[[4]], w)
})

#**** is this the right way to handle :: and ::: ??
#**** maybe record package/name space?
local({
    h <- function(e, w)
        w$enterGlobal("function",as.character(e[[1]]), e, w)
    addCollectUsageHandler("~", "base", h)
    addCollectUsageHandler("quote", "base", h)
    addCollectUsageHandler("expression", "base", h)
    addCollectUsageHandler("::", "base", h)
    addCollectUsageHandler(":::", "base", h)
})

#**** add counter to anonymous functions to distinguish??
addCollectUsageHandler("function", "base", function(e, w)
    collectUsageFun("<anonymous>", e[[2]], e[[3]], w))

addCollectUsageHandler("local", "base", function(e, w) {
    w$enterGlobal("function", "local", e, w)
    if (length(e) == 2)
        collectUsageFun("<local>", NULL, e[[2]], w)
    else collectUsageArgs(e, w)
})

addCollectUsageHandler("assign", "base", function(e, w) {
    w$enterGlobal("function", "assign", e, w)
    if (length(e) == 3 && is.character(e[[2]]) && length(e[[2]]) == 1) {
        w$enterLocal("<-", e[[2]], e, w)
        walkCode(e[[3]], w)
    }
    else collectUsageArgs(e, w)
})

addCollectUsageHandler("with", "base", function(e, w) {
    w$enterGlobal("function", "with", e, w)
    if (identical(w$skipWith, TRUE))
        walkCode(e[[2]], w)
    else collectUsageArgs(e, w)
})

local({
    h <- function(e, w) {
        w$enterGlobal("function", as.character(e[[1]]), e, w)
        walkCode(e[[2]], w)
    }
    addCollectUsageHandler("$", "base", h)
    addCollectUsageHandler("@", "base", h)
})

local({
    h <- function(e, w) {
        w$enterGlobal("function", as.character(e[[1]]), e, w)
        walkCode(e[[2]], w)
        walkCode(e[[4]], w)
    }
    addCollectUsageHandler("$<-", "base", h)
    addCollectUsageHandler("@<-", "base", h)
})

addCollectUsageHandler(".Internal", "base", function(e, w) {
    w$enterGlobal("function", ".Internal", e, w)
    if (length(e) != 2)
        w$signal("wrong number of arguments to .Internal", w)
    if (typeof(e[[2]]) == "language") {
        w$enterInternal(e[[2]][[1]], e[[2]], w)
         collectUsageArgs(e[[2]], w)
    }
    else w$signal(paste("bad argument to .Internal:", deparse(e[[2]])), w)
})

addCollectUsageHandler("substitute", "base", function(e, w) {
    w$enterGlobal("function", "substitute", e, w)
    if (length(e) > 3)
        w$signal("wrong number of arguments to substitute", w)
    if (length(e) == 3) {
        a <- e[[3]]
        if (! missing(a)) walkCode(a, w)
    }
})
findGlobals <- function(fun, merge = TRUE) {
    vars <- new.env(hash = TRUE, parent = NULL)
    funs <- new.env(hash = TRUE, parent = NULL)
    enter  <- function(type, v, e, w)
        if (type == "function")
            assign(v, TRUE, funs)
        else assign(v, TRUE, vars)
    collectUsage(fun, enterGlobal = enter)
    fnames <- ls(funs, all = TRUE)
    vnames <- ls(vars, all = TRUE)
    if (merge)
        sort(unique(c(vnames, fnames)))
    else list(functions = fnames, variables = vnames)
}
checkUsageStartLocals <- function(parnames, locals, w) {
    env <- w$env
    nplocals <- locals[! locals %in% parnames]
    attr(env, "checkUsageFrame") <- env # for sanity check
    mkentry <- function(parameter) {
        entry <- new.env(parent = NULL)
        assign("parameter", parameter, env = entry)
        assign("assigns", 0, env = entry)
        assign("varuses", 0, env = entry)
        assign("funuses", 0, env = entry)
        assign("funforms", NULL, env = entry)
        assign("loopvars", 0, env = entry)
        entry
    }
    for (v in parnames) assign(v, mkentry(TRUE), env = env)
    for (v in nplocals) assign(v, mkentry(FALSE), env = env)
}

getLocalUsageEntry <- function(vn, w) {
    env <- findOwnerEnv(vn, w$env, stop = w$globalenv, default = NULL)
    if (is.null(env)) stop("no local variable entry")
    if (! identical(env, attr(env, "checkUsageFrame")))
        stop("sanity check on local usage frame failed")
    entry <- get(vn, env = env, inherits = FALSE)
    if (! is.environment(entry)) stop("bad local variable entry")
    entry
}

getLocalUsageValue <- function(vn, which, w)
    get(which, getLocalUsageEntry(vn, w), inherits = FALSE)

setLocalUsageValue <- function(vn, which, value, w)
    assign(which, value, env = getLocalUsageEntry(vn, w))

incLocalUsageValue <- function(vn, which, w) {
    entry <- getLocalUsageEntry(vn, w)
    value <- get(which, entry, inherits = FALSE)
    assign(which, value + 1, entry)
}

addLocalFunDef <- function(vn, e, w) {
    entry <- getLocalUsageEntry(vn, w)
    value <- get("funforms", entry, inherits = FALSE)
    assign("funforms", c(value, list(e[[3]][[2]])), entry)
}
    
checkUsageEnterLocal <- function(type, n, e, w) {
    if (type %in% c("<-", "<<-") && isSimpleFunDef(e, w))
        type <- "fundef"
    switch(type,
        "<-" =,
        "<<-" = incLocalUsageValue(n, "assigns", w),
        "variable" = incLocalUsageValue(n, "varuses", w),
        "function" = incLocalUsageValue(n, "funuses", w),
        "for" = incLocalUsageValue(n, "loopvars", w),
        "fundef" = addLocalFunDef(n, e, w))
}

suppressVar <- function(n, suppress) {
    if (is.logical(suppress)) {
        if (suppress) TRUE else FALSE
    }
    else n %in% suppress
}

#**** need test code
#**** merge warnings?
checkUsageFinishLocals <- function(w) {
    vars <- ls(w$env, all = TRUE)
    for (v in vars) {
        if (! suppressVar(v, w$suppressLocal)) {
            parameter <- getLocalUsageValue(v, "parameter", w)
            assigns <- getLocalUsageValue(v, "assigns", w)
            varuses <- getLocalUsageValue(v, "varuses", w)
            funuses <- getLocalUsageValue(v, "funuses", w)
            loopvars <- getLocalUsageValue(v, "loopvars", w)
            funforms <- getLocalUsageValue(v, "funforms", w)
            uses <- max(varuses, funuses, loopvars)
            if (parameter) {
                if (! suppressVar(v, w$suppressParamAssigns) && assigns > 0)
                    w$signal(paste("parameter", v,
                                   "changed by assignment"), w)
                else if (! suppressVar(v, w$suppressParamUnused) &&
                         uses == 0 && v != "...")
                    w$signal(paste("parameter", v, "may not be used"), w)
            }
            else {
                if (uses == 0) {
                    if (! suppressVar(v, w$suppressLocalUnused))
                        w$signal(paste("local variable", v,
                                       "assigned but may not be used"), w)
                }
                else if (funuses > 0 && is.null(funforms)) {
                    if (! suppressVar(v, w$suppressNoLocalFun))
                        w$signal(paste("local variable", v,
                                       "used as function with no apparent",
                                       "local function definition"), w)
                }
            }
            if (! suppressVar(v, w$suppressFundefMismatch) &&
                length(funforms) > 1) {
                first <- funforms[[1]]
                nfirst <- names(first)
                for (d in funforms[-1])
                    if (! identical(first, d) ||
                        ! identical(nfirst, names(d))) {
                        w$signal(paste("multiple local function",
                                       "definitions for", v,
                                       "with different formal arguments"), w)
                        break
                    }
            }
        }
    }
}

#**** warn if non-function used as variable (most likely get false positives)
#**** merge warnings?
checkUsageEnterGlobal <- function(type, n, e, w) {
    if (type == "function") {
        if (exists(n, env = w$globalenv, mode = "function")) {
            # **** better call check here
            def <- get(n, env = w$globalenv, mode = "function")
            if (typeof(def) == "closure")
                checkCall(def, e, function(m) w$signal(m, w))
            else checkPrimopCall(n, e, function(m) w$signal(m, w))
        }
        else if (! suppressVar(n, w$suppressUndefined))
            w$signal(paste("no visible global function definition for", n), w)
    }
    else if (type == "variable") {
        if (! exists(n, w$globalenv) && ! suppressVar(n, w$suppressUndefined))
            w$signal(paste("no visible binding for global variable", n), w)
    }
    else if (type == "<<-") {
        if (! exists(n, w$globalenv))
            w$signal(paste("no visible binding for '<<-' assignment to", n), w)
    }
}

dfltSuppressUndefined <- c(".Generic", ".Method",
    ".split.valid.screens", ".split.cur.screen", ".split.saved.pars",
    ".split.screens", ".split.par.list", "last.dump")

#**** merge undefined variable warnings per top level function (at least)
#**** allow complete suppress or by name for all??
checkUsage <- function(fun, name = "<anonymous>",
                       report = cat,
                       all = FALSE,
                       suppressLocal = FALSE,
                       suppressParamAssigns = ! all,
                       suppressParamUnused = !all,
                       suppressFundefMismatch = FALSE,
                       suppressLocalUnused = FALSE,
                       suppressNoLocalFun = ! all,
                       skipWith = FALSE,
                       suppressUndefined = dfltSuppressUndefined)
    collectUsage(fun, name = name,
                 warn = report,
                 suppressLocal = suppressLocal,
                 suppressParamAssigns = suppressParamAssigns,
                 suppressParamUnused = suppressParamUnused,
                 suppressFundefMismatch = suppressFundefMismatch,
                 suppressLocalUnused = suppressLocalUnused,
                 suppressNoLocalFun = suppressNoLocalFun,
                 skipWith = skipWith,
                 enterGlobal = checkUsageEnterGlobal,
                 enterLocal = checkUsageEnterLocal,
                 startCollectLocals = checkUsageStartLocals,
                 finishCollectLocals = checkUsageFinishLocals,
                 suppressUndefined = suppressUndefined)

checkUsageEnv <- function(env, ...) {
    for (n in ls(env, all=TRUE)) {
        v <- get(n, env = env)
        if (typeof(v)=="closure")
            checkUsage(v, name = n, ...)
    }
}
checkUsagePackage <- function(pack, ...) {
    pname <- paste("package", pack, sep = ":")
    if (! pname %in% search())
        stop("package must be loaded")
    if (pack %in% loadedNamespaces())
        checkUsageEnv(getNamespace(pack), ...)
    else checkUsageEnv(as.environment(pname), ...)
}
#++++ check against internal arg count?

primopArgCounts <- new.env(hash = TRUE, parent = NULL)

checkPrimopCall <- function(fn, e, signal = warning) {
    if (exists(fn, env = primopArgCounts, inherits = FALSE)) {
        argc <- get(fn, env = primopArgCounts)
        if (! any(argc == (length(e) - 1))) {
            signal(paste("wrong number of arguments to", fn))
            FALSE
        }
        else TRUE
    }
    else TRUE
}

local({
    zeroArgPrims <- c("break", "browser", "gc.time", "globalenv",
                      "interactive", "nargs", "next", "proc.time")
    for (fn in zeroArgPrims) assign(fn, 0, env = primopArgCounts)

    zeroOrOneArgPrims <- c("invisible")
    for (fn in zeroOrOneArgPrims) assign(fn, 0:1, env = primopArgCounts)

    oneArgPrims <- c("!", "(", "abs", "sqrt", "cos", "sin", "tan", "acos",
                     "asin", "atan", "Re", "Im", "Mod", "Arg", "Conj",
                     "cosh", "sinh", "tanh", "acosh", "asinh", "atanh",
                     "sign", "length", "repeat", ".Primitive",
                     "class", "oldClass", "standardGeneric", "unclass",
                     "ceiling", "floor", "trunc",
                     "is.array", "is.atomic", "is.call", "is.character",
                     "is.complex", "is.double",
                     "is.environment", "is.expression", "is.finite",
                     "is.function", "is.infinite", "is.integer",
                     "is.language", "is.list", "is.loaded", "is.logical",
                     "is.matrix", "is.na", "is.name", "is.nan", "is.null",
                     "is.numeric", "is.object", "is.pairlist", "is.real",
                     "is.recursive", "is.single", "is.symbol",
                     "debug", "undebug", "as.character", "as.call",
                     "as.environment", "attributes", "cumsum", "cumprod",
                     "cummax", "cummin", "dim", "dimnames", "exp", "missing",
                     "pos.to.env", ".primTrace", ".primUntrace",
                     "symbol.C", "symbol.For")
    for (fn in oneArgPrims) assign(fn, 1, env = primopArgCounts)

    oneOrTwoArgPrims <- c("+", "-")
    for (fn in oneOrTwoArgPrims) assign(fn, 1:2, env = primopArgCounts)

    twoArgPrims <- c("*", "/", "%%", "^", "<", "<=", "==", ">", ">=",
                     "|", "||", ":", "!=", "&", "&&", "%/%", "%*%",
                     "while", "attr", "attributes<-", "class<-",
                     "oldClass<-", "dim<-", "dimnames<-", "environment<-",
                     "length<-", "reg.finalizer")
    for (fn in twoArgPrims) assign(fn, 2, env = primopArgCounts)

    assign("on.exit", 0:2, primopArgCounts)
})
n2d <- function(name, color = NULL) {
    if (is.null(color) || is.na(color))
        paste("\"", name, "\";\n", sep = "")
    else
        paste("\"", name, "\"[style=filled,color=\"", color, "\"];\n",
              sep = "")
}

e2d <- function(from, to, color = NULL) {
    e <- paste("\"", from, "\" -> \"", to, "\"", sep = "")
    if (is.null(color))
        paste(e, ";\n", sep = "")
    else
        paste(e, "[color=\"", color, "\"];\n", sep = "")
}

# **** A plausible size is 10,7.5
g2d <- function(g, filename = "g.dot", landscape = TRUE,
                nodeColors = NULL, edgeColors = NULL,
                size, center = FALSE, rankdir = c("TB","LR")) {
    if (missing(rankdir))
        rankdir = "LR"
    else match.arg(rankdir)

    con <- file(filename, open = "w")
    on.exit(close(con))

    cat("digraph xyz {\n", file = con)
    if (! missing(size))
        cat(paste("size=\"", size, "\";\n", sep = ""), file = con)
    if (landscape)
        cat("rotate=90;\n", file = con)
    if (center)
        cat("center=1;\n", file = con)
    cat(paste("rankdir=", rankdir, ";\n", sep = ""), file = con)
    for (i in seq(along = g$nodes)) {
        from <- g$nodes[i]
        cat(n2d(from, nodeColors[[i]]), file = con)
        toList <- g$edges[[i]]
        toColors <- edgeColors[[i]]
        for (j in seq(along = toList))
            cat(e2d(from, toList[[j]], toColors[[j]]), file = con)
    }
    cat("}", file = con)
}

g2g <- function(g) {
    if (! require(graph))
        stop("package graph is needed but not available")
    # **** eventually maybe do new("graph::graphNEL") here
    nodes <- g$nodes
    mke <- function(e) if (length(e) > 0) list(edges = match(e, nodes))
    eL <- lapply(g$edges, mke)
    names(eL) <- nodes
    new("graphNEL", nodes = nodes, edgeL = eL, edgemode = "directed")
}
cg <- function(funs, envir = .GlobalEnv, restrict = NULL) {
    fg <- function(fn) {
        if (exists(fn, env = envir)) {
            def <- get(fn, env = envir)
            if (typeof(def) == "closure") {
                g <- findGlobals(def)
                if (is.null(restrict)) g
                else g[g %in% restrict]

            }
            else if (! is.function(def)) {
                warning(paste(fn, "is not a function"))
                character(0)
            }
            else character(0)
        }
        else {
            warning(paste("no definition for", fn))
            character(0)
        }
    }
    edges <- lapply(funs, fg)
    toNodes <- unique(unlist(edges))
    extra <- toNodes[! toNodes %in% funs]
    extraEdges <- rep(list(character(0)), length(extra))
    list(nodes = c(funs, extra), edges = c(edges, extraEdges))
}

cg2d <- function(g, filename = "cg.dot", landscape = TRUE) {
    con <- file(filename, open = "w")
    on.exit(close(con))
    cat("digraph xyz {\n", file = con)
    cat("size=\"10,7.5\";\n", file = con)
    if (landscape) cat("rotate=90;\n", file = con)
    cat("center=1;\n", file = con)
    for (n in g$nodes)
        cat(paste("\"", n, "\";\n", sep = ""), file = con)
    for (i in seq(along = g$nodes)) {
        from <- g$nodes[i]
        for (to in g$edges[[i]])
            cat(paste("\"", from, "\" -> \"", to, "\";\n", sep = ""),
                file = con)
    }
    cat("}", file = con)
}

cgp<-function(pack) {
    if (! paste("package", pack, sep = ":") %in% search())
        stop(paste("package", pack, "is not attached"));
    plib <- dirname(attr(as.environment("package:methods"), "path"))
    if (packageHasNamespace(pack, plib)) {
        ns <- getNamespace(pack)
        names <- ls(ns, all = TRUE)
        isFunName <- function(x) is.function(get(x, env = ns))
        funs <- names[sapply(names, isFunName)]
        cg(funs, env = ns, restrict = funs)
    }
    else {
        names <- ls(paste("package", pack, sep = ":"), all = TRUE)
        isFunName <- function(x) is.function(get(x, env = .GlobalEnv))
        funs <- names[sapply(names, isFunName)]
        cg(funs, env = .GlobalEnv, restrict = funs)
    }
}
matchName <- function(name, list)
    if (match(as.character(name), list, 0)) TRUE else FALSE

findVar <- function(e, env) matchName(e, env)
checkCall <- function(def, call, signal = warning) {
    testMatch <- function(...) match.call(def, call, FALSE)
    msg <- try({testMatch(); NULL}, silent = TRUE)
    if (! is.null(msg)) {
        msg<-sub("\n$","",sub("^E.*: ","",msg))
        emsg<-paste("possible error in ", deparse(call),": ", msg, sep="")
        if (! is.null(signal)) signal(emsg)
        FALSE
    }
    else TRUE
}
#***** need special for others?
#***** separate out function and variable usage
findGlobals0 <- function(e, env = NULL) {
    if (typeof(e) == "language") {
        if (typeof(e[[1]]) == "symbol" || is.character(e[[1]])) {
            fun <- as.character(e[[1]])
            switch(fun,
                "function" = findFuncGlobals0(e[[2]], e[[3]], env),
                "local" =  #**** only ok if single arg
                   unique(c("local",
                            findGlobals0(e[[2]],
                                        unique(c(findLocals(e[[2]]), env))))),
                ".Internal" = unique(c(".Internal",
                                       findGlobalsInList0(e[[2]][-1], env))),
                "~" =,   # could argue that formula variables should count
                "expression" =,
                "quote" = fun,
                "substitute" =
                    {
                        if (length(e) == 3) {
                            a <- e[[3]]
                            if (missing(a)) fun
                            else unique(c(fun,findGlobals0(e[[3]], env)))
                        }
                        else fun
                    },
                "=" =,
                "<<-" =,
                "<-" =
                     if (typeof(e[[2]]) == "language") {
                         fa <- flattenAssignment(e[[2]])
                         fal <- c(fa[[1]], fa[[2]], list(e[[3]]))
                         nenv <- c("*tmp*","*tmpv*", env)
                         unique(c(fun, findGlobalsInList0(fal, nenv)))
                     }
                     else findGlobalsInList0(e, env),
                "$" =,
                "@" = unique(c(fun, findGlobals0(e[[2]], env))),
                "$<-" =,
                "$@<-" = findGlobalsInList0(e[-3], env),
                "::" =,
                ":::" = fun,
                findGlobalsInList0(e, env))
        }
        else findGlobalsInList0(e, env)
    }
    else if (typeof(e) == "symbol" && ! findVar(e, env))
        as.character(e)
    else if (typeof(e) == "closure")
        findFuncGlobals0(formals(e), body(e), env)
}

funEnv <- function(forms, body, env = NULL)
    unique(c(names(forms), findLocals(body), env))

findFuncGlobals0 <- function(formals, body, env)
    findGlobalsInList0(c(formals, list(body)), funEnv(formals, body, env))

findGlobalsInList0 <- function(el, env)
    unique(unlist(lapply(dropMissings(as.list(el)), findGlobals0, env)))

getAssignFuncs <- function(e, env) {
    val <- NULL
    v <- e[[2]];
    while (typeof(v) == "language") {
        if (typeof(v[[1]]) != "symbol" && typeof(v[[1]]) != "character")
            stop("bad assignment expression")
        afun <- paste(as.character(v[[1]]), "<-", sep="")
        if (! findVar(afun, env))
            val <- unique(c(afun, val))
        v <- v[[2]]
    }
    if (typeof(v) != "symbol" && typeof(v) != "character")
        stop(paste("bad assignment:", as.expression(e)))
    val
}
                        
recursiveFindGlobals <- function(roots) {
    vals <- NULL
    while (length(roots) > 0) {
        vals <- unique(c(roots[1], vals))
        if (exists(roots[1])) {
            new <- findGlobals(get(roots[1]), vals)
            vals <- unique(c(new, vals))
            roots <- unique(c(new, roots[-1]))
        }
        else roots <- roots[-1]
    }
    vals
}

localEnvVars <- function(env) {
    vars <- NULL;
    top <- topenv(env)
    if (is.null(top)) stop("can't find top level environment")
    while (! identical(env, top)) {
        vars <- unique(c(ls(env, all=TRUE), vars))
        env <- parent.env(env)
    }
    vars
}
makeAssignTemps <- function(lhs, index=1) {
    if (typeof(lhs) == "language") {
        tail <- makeAssignTemps(lhs[[2]], index + 1)
        lhs[[2]] <- tail[[1]][[2]]
        tmpvar <- as.name(paste("tmp", index,sep=""))
        c(tail, list(as.call(list(as.name("<-"), tmpvar, lhs))))
    }
    else if (typeof(lhs) == "symbol")
        list(as.call(list(as.name("<-"), lhs, lhs)))
    else stop("bad assignment expression")
}

makeAssigns <- function(lhs, v, index = 1) {
    if (typeof(lhs) == "language") {
        nextlhs <- lhs[[2]]
        lhs[[2]] <- as.name(paste("tmp", index,sep=""))
        lhs[[1]] <- paste(as.character(lhs[[1]]), "<-", sep="")
        v <- as.call(c(as.list(lhs), list(value = v)))
        makeAssigns(nextlhs, v, index + 1)
    }
    else if (typeof(lhs) == "symbol")
        as.call(list(as.name("<-"), lhs, v))
    else stop("bad assignment expression")
}

#******* this is wrong!!!
flattenComplexAssign <- function(e)
    c(makeAssignTemps(e[[2]]), list(makeAssigns(e[[2]], e[[3]])))
dotsOrMissing <- function(args) {
    for (i in 1:length(args)) {
        a <-args[[i]]
        if (missing(a)) return(TRUE) #**** better test?
        if (typeof(a) == "symbol" && a == "...") return(TRUE)
    }
    return(FALSE)
}

anyDots <- function(args) {
    for (i in 1:length(args)) {
        a <-args[[i]]
        if (! missing(a) && typeof(a) == "symbol" && a == "...")
            return(TRUE)
    }
    return(FALSE)
}

isDDSym <- function(name) {
    (is.symbol(name) || is.character(name)) &&
    length(grep("^\\.\\.[0-9]*$", as.character(name))) != 0
}
